/*

 Licensed under the Apache License, Version 2.0 (the "License"); you may not
 use this file except in compliance with the License. You may obtain a copy 
 of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 License for the specific language governing permissions and limitations under
 the License.

 Copyright (c) 2011 Almende B.V.

 @author 	Jos de Jong, <jos@almende.org>
 @date	  2011-08-25 
*/
var links;links===void 0&&(links={});
links.Network=function(a){this.containerElement=a;this.height=this.width="100%";this.refreshRate=50;this.selectable=this.stabilize=!0;this.constants={nodes:{radiusMin:5,radiusMax:20,radius:5,distance:100,style:"rect",image:void 0,fontColor:"black",fontSize:14,fontFace:"verdana",borderColor:"#2B7CE9",backgroundColor:"#97C2FC",highlightColor:"#D2E5FF",group:void 0},links:{widthMin:1,widthMax:15,width:1,style:"line",color:"#2B7CE9",length:100},packages:{radiusMin:5,radiusMax:10,style:"dot",radius:5,
color:"#2B7CE9",image:void 0,duration:1},minVelocity:0.01,maxIterations:1E3};this.nodes=[];this.links=[];this.packages=[];this.images=new links.Network.Images;this.groups=new links.Network.Groups;this.hasMovingPackages=this.hasMovingNodes=this.hasMovingLinks=!1;this.timer=void 0;this._create()};
links.Network.prototype.draw=function(a,b,c,e){if(e!=void 0)var f=a,g=b,h=c;else c!=void 0?(f=a,g=b,h=void 0,e=c):b!=void 0?(f=a,h=g=void 0,e=b):a!=void 0&&(h=g=f=void 0,e=a);if(e!=void 0){if(e.width!=void 0)this.width=e.width;if(e.height!=void 0)this.height=e.height;if(e.stabilize!=void 0)this.stabilize=e.stabilize;if(e.selectable!=void 0)this.selectable=e.selectable;if(e.links){for(prop in e.links)e.links.hasOwnProperty(prop)&&(this.constants.links[prop]=e.links[prop]);if(e.links.length!=void 0&&
e.links.distance==void 0)this.constants.links.length=e.links.length,this.constants.nodes.distance=e.links.length*1.25}if(e.nodes)for(prop in e.nodes)e.nodes.hasOwnProperty(prop)&&(this.constants.nodes[prop]=e.nodes[prop]);if(e.packages)for(prop in e.packages)e.packages.hasOwnProperty(prop)&&(this.constants.packages[prop]=e.packages[prop]);if(e.groups)for(groupname in e.groups)e.groups.hasOwnProperty(groupname)&&this.groups.add(groupname,e.groups[groupname])}this._setBackgroundColor(e.backgroundColor);
this._setSize(this.width,this.height);this._setTranslation(0,0);this._setScale(1);this.hasTimestamps=!1;this.setNodes(f);this.setLinks(g);this.setPackages(h);this._reposition();this.stabilize&&this._doStabilize();this.start();var i=this;this.images.setOnloadCallback(function(){i._redraw()});google.visualization.events.trigger(this,"ready",null)};
links.Network.prototype._create=function(){for(;this.containerElement.hasChildNodes();)this.containerElement.removeChild(this.containerElement.firstChild);this.frame=document.createElement("div");this.frame.className="network-frame";this.frame.style.position="relative";this.frame.style.overflow="hidden";this.frame.canvas=document.createElement("canvas");this.frame.canvas.style.position="relative";this.frame.appendChild(this.frame.canvas);if(!this.frame.canvas.getContext){var a=document.createElement("DIV");
a.style.color="red";a.style.fontWeight="bold";a.style.padding="10px";a.innerHTML="Error: your browser does not support HTML canvas";this.frame.canvas.appendChild(a)}var b=this;links.Network.addEventListener(this.frame.canvas,"mousedown",function(a){b._onMouseDown(a)});links.Network.addEventListener(this.frame.canvas,"mousemove",function(a){b._onMouseMoveTitle(a)});links.Network.addEventListener(this.frame.canvas,"mousewheel",function(a){b._onMouseWheel(a)});links.Network.addEventListener(this.frame.canvas,
"touchstart",function(a){b._onTouchStart(a)});this.containerElement.appendChild(this.frame)};
links.Network.prototype._setBackgroundColor=function(a){var b="white",c="#666",e=1;if(typeof a=="string")b=a,c="none",e=0;else if(typeof a=="object"){if(a.fill!=void 0)b=a.fill;if(a.stroke!=void 0)c=a.stroke;if(a.strokeWidth!=void 0)e=a.strokeWidth}else if(a!=void 0)throw"Unsupported type of backgroundColor";this.frame.style.backgroundColor=b;this.frame.style.borderColor=c;this.frame.style.borderWidth=e+"px";this.frame.style.borderStyle="solid"};
links.Network.prototype._onMouseDown=function(a){a=a||window.event;if(this.selectable&&(this.leftButtonDown&&this._onMouseUp(a),(this.leftButtonDown=a.which?a.which==1:a.button==1)||this.touchDown)){var b=this;this.onmousemove=function(a){b._onMouseMove(a)};this.onmouseup=function(a){b._onMouseUp(a)};links.Network.addEventListener(document,"mousemove",b.onmousemove);links.Network.addEventListener(document,"mouseup",b.onmouseup);links.Network.preventDefault(a);this.startMouseX=a.clientX||a.targetTouches[0].clientX;
this.startMouseY=a.clientY||a.targetTouches[0].clientY;this.startFrameLeft=links.Network._getAbsoluteLeft(this.frame.canvas);this.startFrameTop=links.Network._getAbsoluteTop(this.frame.canvas);this.startTranslation=this._getTranslation();this.ctrlKeyDown=a.ctrlKey;this.shiftKeyDown=a.shiftKey;a=this._getNodesOverlappingWith({left:this._xToCanvas(this.startMouseX-this.startFrameLeft),top:this._yToCanvas(this.startMouseY-this.startFrameTop),right:this._xToCanvas(this.startMouseX-this.startFrameLeft),
bottom:this._yToCanvas(this.startMouseY-this.startFrameTop)});if(this.startClickedObj=a.length>0?a[a.length-1]:void 0)a=this.nodes[this.startClickedObj.row],this.startClickedObj.xFixed=a.xFixed,this.startClickedObj.yFixed=a.yFixed,a.xFixed=!0,a.yFixed=!0,!this.ctrlKeyDown||!a.isSelected()?this._selectNodes([this.startClickedObj],this.ctrlKeyDown):this._unselectNodes([this.startClickedObj]),this.hasMovingNodes||this._redraw();else if(!this.shiftKeyDown)this.moved=!1}};
links.Network.prototype._onMouseMove=function(a){a=a||window.event;if(this.selectable){var b=a.clientX||a.targetTouches&&a.targetTouches[0].clientX||0,c=a.clientY||a.targetTouches&&a.targetTouches[0].clientY||0;if(this.startClickedObj){var e=this.nodes[this.startClickedObj.row];if(!this.startClickedObj.xFixed)e.x=this._xToCanvas(b-this.startFrameLeft);if(!this.startClickedObj.yFixed)e.y=this._yToCanvas(c-this.startFrameTop);if(!this.hasMovingNodes)this.hasMovingNodes=!0,this.start()}else if(this.shiftKeyDown){if(this.frame.selRect==
void 0)this.frame.selRect=document.createElement("DIV"),this.frame.appendChild(this.frame.selRect),this.frame.selRect.style.position="absolute",this.frame.selRect.style.border="1px dashed red";var e=Math.min(this.startMouseX,b)-this.startFrameLeft,f=Math.min(this.startMouseY,c)-this.startFrameTop,b=Math.max(this.startMouseX,b)-this.startFrameLeft,c=Math.max(this.startMouseY,c)-this.startFrameTop;this.frame.selRect.style.left=e+"px";this.frame.selRect.style.top=f+"px";this.frame.selRect.style.width=
b-e+"px";this.frame.selRect.style.height=c-f+"px"}else this._setTranslation(this.startTranslation.x+(b-this.startMouseX),this.startTranslation.y+(c-this.startMouseY)),this._redraw(),this.moved=!0;links.Network.preventDefault(a)}};
links.Network.prototype._onMouseUp=function(a){a=a||window.event;if(this.selectable){links.Network.removeEventListener(document,"mousemove",this.onmousemove);links.Network.removeEventListener(document,"mouseup",this.onmouseup);links.Network.preventDefault(a);var b=a.clientX||a.targetTouches[0].clientX,c=a.clientY||a.targetTouches[0].clientY,a=a?a.ctrlKey:window.event.ctrlKey;if(this.startClickedObj)b=this.nodes[this.startClickedObj.row],b.xFixed=this.startClickedObj.xFixed,b.yFixed=this.startClickedObj.yFixed;
else if(this.shiftKeyDown){if(this._selectNodes(this._getNodesOverlappingWith({left:this._xToCanvas(Math.min(this.startMouseX,b)-this.startFrameLeft),top:this._yToCanvas(Math.min(this.startMouseY,c)-this.startFrameTop),right:this._xToCanvas(Math.max(this.startMouseX,b)-this.startFrameLeft),bottom:this._yToCanvas(Math.max(this.startMouseY,c)-this.startFrameTop)}),a),this.redraw(),this.frame.selRect)this.frame.removeChild(this.frame.selRect),this.frame.selRect=void 0}else!this.ctrlKeyDown&&!this.moved&&
(this._unselectNodes(),this._redraw());this.ctrlKeyDown=this.leftButtonDown=!1}};
links.Network.prototype._onMouseWheel=function(a){var a=a||window.event,b=a.clientX,c=a.clientY,e=0;a.wheelDelta?e=a.wheelDelta/120:a.detail&&(e=-a.detail/3);if(e){var f=e/10;e<0&&(f/=1-f);e=this._getScale();f=e*(1+f);f<0.01&&(f=0.01);f>10&&(f=10);var g=links.Network._getAbsoluteLeft(this.frame.canvas),h=links.Network._getAbsoluteTop(this.frame.canvas);b-=g;c-=h;h=this._getTranslation();e=f/e;b=(1-e)*b+h.x*e;e=(1-e)*c+h.y*e;this._setScale(f);this._setTranslation(b,e);this._redraw()}links.Network.preventDefault(a)};
links.Network.prototype._onMouseMoveTitle=function(a){var a=a||window.event,b=a.clientX,a=a.clientY;this.startFrameLeft=this.startFrameLeft||links.Network._getAbsoluteLeft(this.frame.canvas);this.startFrameTop=this.startFrameTop||links.Network._getAbsoluteTop(this.frame.canvas);var c=b-this.startFrameLeft,e=a-this.startFrameTop;this.popupNode&&this._checkHidePopup(c,e);var f=this,b=function(){f._checkShowPopup(c,e)};this.popupTimer&&clearInterval(this.popupTimer);if(!this.leftButtonDown)this.popupTimer=
setTimeout(b,300)};
links.Network.prototype._checkShowPopup=function(a,b){var c={left:this._xToCanvas(a),top:this._yToCanvas(b),right:this._xToCanvas(a),bottom:this._yToCanvas(b)},e=this.popupNode;if(this.popupNode==void 0)for(var f=0,g=this.packages.length;f<g;f++){var h=this.packages[f];if(h.getTitle()!=void 0&&h.isOverlappingWith(c)){this.popupNode=h;break}}if(this.popupNode==void 0){g=this.nodes;for(f=g.length-1;f>0;f--)if(h=g[f],h.getTitle()!=void 0&&h.isOverlappingWith(c)){this.popupNode=h;break}}if(this.popupNode==void 0){h=
this.links;f=0;for(g=h.length;f<g;f++){var i=h[f];if(i.getTitle()!=void 0&&i.isOverlappingWith(c)){this.popupNode=i;break}}}if(this.popupNode){if(this.popupNode!=e){if(!this.popup)this.popup=new links.Network.Popup(this.frame);this.popup.setPosition(a-3,b-3);this.popup.setText(this.popupNode.getTitle());this.popup.show()}}else this.popup&&this.popup.hide()};
links.Network.prototype._checkHidePopup=function(a,b){var c={left:a,top:b,right:a,bottom:b};if(!this.popupNode||!this.popupNode.isOverlappingWith(c))this.popupNode=void 0,this.popup&&this.popup.hide()};
links.Network.prototype._onTouchStart=function(a){this.touchDown=!0;var b=this;this.ontouchmove=function(a){b._onTouchMove(a)};this.ontouchend=function(a){b._onTouchEnd(a)};links.Network.addEventListener(document,"touchmove",b.ontouchmove);links.Network.addEventListener(document,"touchend",b.ontouchend);this._onMouseDown(a)};links.Network.prototype._onTouchMove=function(a){this._onMouseMove(a)};
links.Network.prototype._onTouchEnd=function(a){this.touchDown=!1;links.Network.removeEventListener(document,"touchmove",this.ontouchmove);links.Network.removeEventListener(document,"touchend",this.ontouchend);this._onMouseUp(a)};
links.Network.prototype._unselectNodes=function(a){if(a)for(var b=0,c=a.length;b<c;b++){var e=a[b].row;this.nodes[e].unselect();for(var f=0,g=this.selection.length;f<g;f++)this.selection[f].row==e&&this.selection.splice(f,1)}else if(this.selection){b=0;for(c=this.selection.length;b<c;b++)e=this.selection[b].row,this.nodes[e].unselect();this.selection=[]}};
links.Network.prototype._selectNodes=function(a,b){(b==void 0||b==!1)&&this._unselectNodes();for(var c=0,e=a.length;c<e;c++){for(var f=a[c].row,g=!1,h=0,i=this.selection.length;h<i;h++)if(this.selection[h].row==f){g=!0;break}g||(this.nodes[f].select(),this.selection.push(a[c]))}a.length>0&&google.visualization.events.trigger(this,"select",null)};
links.Network.prototype._getNodesOverlappingWith=function(a){for(var b=[],c=0;c<this.nodes.length;c++)this.nodes[c].isOverlappingWith(a)&&b.push({row:c});return b};links.Network.prototype.getSelection=function(){return this.selection};
links.Network.prototype.setSelection=function(a){if(a.length==void 0)throw"Selection must be an array with objects";for(var b=0,c=this.selection.length;b<c;b++){var e=this.selection[b].row;this.nodes[e].unselect()}this.selection=[];b=0;for(c=a.length;b<c;b++){e=a[b].row;if(e==void 0)throw"Parameter row missing in selection object";if(e>this.nodes.length-1)throw"Parameter row out of range";this.selection.push({row:e});this.nodes[e].select()}this.redraw()};
links.Network.prototype._getConnectionCount=function(a){function b(a){for(var b=[],e=0,f=a.length;e<f;e++)for(var g=a[e],h=0,i=c.length;h<i;h++){var j=null;if(c[h].from==g)j=c[h].to;else if(c[h].to==g)j=c[h].from;if(j)for(var l=0,m=a.length;l<m;l++)if(a[l]==j){j=null;break}if(j){l=0;for(m=b.length;l<m;l++)if(b[l]==j){j=null;break}}j&&b.push(j)}return b}var c=this.links;a==void 0&&(a=1);for(var e=[],f=this.nodes,g=0,h=f.length;g<h;g++){for(var i=[f[g]],j=0;j<a;j++)i=i.concat(b(i));e.push(i)}a=[];g=
0;for(f=e.length;g<f;g++)a.push(e[g].length);return a};links.Network.prototype._setSize=function(a,b){this.frame.style.width=a;this.frame.style.height=b;this.frame.canvas.style.width="100%";this.frame.canvas.style.height="100%";this.frame.canvas.width=this.frame.canvas.clientWidth;this.frame.canvas.height=this.frame.canvas.clientHeight;this.slider&&this.slider.redraw()};
links.Network.prototype.addNodes=function(a){if(a!==void 0){var b=this._getColumnNames(a);if(b.id==void 0)throw"Column 'id' missing in table with nodes";for(var c=a.getNumberOfRows(),e=0;e<c;e++){var f={},g;for(g in b)if(b.hasOwnProperty(g)){var h=a.getValue(e,b[g]);f[g]=h}this._createNode(f)}b.value!==void 0&&this._updateValueRange(this.nodes);this.start()}};
links.Network.prototype.setNodes=function(a){this.hasMovingNodes=!1;this.nodesTable=a;this.nodes=[];this.selection=[];if(a!==void 0){var b=this._getColumnNames(a);if(b.id==void 0)throw"Column 'id' missing in table with nodes";for(var c=a.getNumberOfRows(),e=0;e<c;e++){var f={},g;for(g in b)if(b.hasOwnProperty(g)){var h=a.getValue(e,b[g]);f[g]=h}this.hasTimestamps=this.hasTimestamps||f.timestamp!==void 0;this._createNode(f)}b.value!==void 0&&this._updateValueRange(this.nodes)}};
links.Network.prototype._filterNodes=function(a){if(this.nodesTable!=void 0){var b=this._getColumnNames(this.nodesTable);if(b.id===void 0)throw"Column 'id' missing in table with nodes";if(a!==void 0)for(var c=this.nodes,e=0;e<c.length;){var f=c[e].timestamp;f!==void 0&&f>a?c.splice(e,1):e++}c=this.nodesTable;e=c.getNumberOfRows();if(b.timestamp!==void 0)for(f=0;f<e;f++){var g={},h;for(h in b)b.hasOwnProperty(h)&&(g[h]=c.getValue(f,b[h]));var i=g.timestamp?g.timestamp:void 0,j=!0;i!==void 0&&a!==void 0&&
i>a&&(j=!1);j&&this._createNode(g)}this.start()}};
links.Network.prototype._createNode=function(a){var b=a.action?a.action:"update";if(b==="create"){var b=new links.Network.Node(a,this.images,this.groups,this.constants),c=a.id,e=c!==void 0?this._findNode(c):void 0;e!==void 0?this.nodes[e]=b:this.nodes.push(b);if(!b.isFixed())this.hasMovingNodes=!0}else if(b==="update"){c=a.id;if(c===void 0)throw"Cannot update a node without id";e=this._findNode(c);if(e!==void 0)this.nodes[e].setProperties(a);else if(b=new links.Network.Node(a,this.images,this.groups,
this.constants),this.nodes.push(b),!b.isFixed())this.hasMovingNodes=!0}else if(b==="delete"){c=a.id;if(c===void 0)throw"Cannot delete node without its id";e=this._findNode(c);if(e!==void 0)this.nodes.splice(e,1);else throw"Node with id "+c+" not found";}else throw"Unknown action "+b+". Choose 'create', 'update', or 'delete'.";};links.Network.prototype._findNode=function(a){for(var b=this.nodes,c=0,e=b.length;c<e;c++)if(b[c].id===a)return c};
links.Network.prototype.setLinks=function(a){this.linksTable=a;this.links=[];this.hasMovingLinks=!1;if(a!==void 0){var b=this._getColumnNames(a);if(b.from===void 0)throw"Column 'from' missing in table with links";if(b.to===void 0)throw"Column 'to' missing in table with links";for(var c=a.getNumberOfRows(),e=0;e<c;e++){var f={},g;for(g in b)b.hasOwnProperty(g)&&(f[g]=a.getValue(e,b[g]));this.hasTimestamps=this.hasTimestamps||f.timestamp!==void 0;this._createLink(f)}b.value!==void 0&&this._updateValueRange(this.links)}};
links.Network.prototype.addLinks=function(a){if(a!==void 0){var b=this._getColumnNames(a);if(b.from===void 0)throw"Column 'from' missing in table with links";if(b.to===void 0)throw"Column 'to' missing in table with links";for(var c=a.getNumberOfRows(),e=0;e<c;e++){var f={},g;for(g in b)b.hasOwnProperty(g)&&(f[g]=a.getValue(e,b[g]));this._createLink(f)}b.value!==void 0&&this._updateValueRange(this.links);this.start()}};
links.Network.prototype._filterLinks=function(a){if(this.linksTable!=void 0){var b=this._getColumnNames(this.linksTable);if(b.from==void 0)throw"Column 'from' missing in table with links";if(b.to==void 0)throw"Column 'to' missing in table with links";if(a!==void 0)for(var c=this.links,e=0;e<c.length;){var f=c[e].timestamp;f!==void 0&&f>a?c.splice(e,1):e++}c=this.linksTable;e=c.getNumberOfRows();if(b.timestamp!==void 0)for(f=0;f<e;f++){var g={},h;for(h in b)b.hasOwnProperty(h)&&(g[h]=c.getValue(f,
b[h]));var i=g.timestamp?g.timestamp:void 0,j=!0;i!==void 0&&a!==void 0&&i>a&&(j=!1);j&&this._createLink(g)}this.start()}};
links.Network.prototype._createLink=function(a){var b=a.action?a.action:"create";if(b==="create"){var c=a.id,b=c!==void 0?this._findLink(c):void 0,c=new links.Network.Link(a,this,this.constants);b!==void 0?this.links[b]=c:this.links.push(c);if(c.isMoving())this.hasMovingLinks=!0}else if(b==="update"){c=a.id;if(c===void 0)throw"Cannot update a link without id";b=this._findLink(c);if(b!==void 0)c=this.links[b],c.setProperties(a);else if(c=new links.Network.Link(a,this,this.constants),this.links.push(c),
c.isMoving())this.hasMovingLinks=!0}else if(b==="delete"){c=a.id;if(c===void 0)throw"Cannot delete link without its id";b=this._findLink(c);if(b!==void 0)this.links.splice(b,1);else throw"Link with id "+c+" not found";}else throw"Unknown action "+b+". Choose 'create', 'update', or 'delete'.";};links.Network.prototype._updateNodeReferences=function(a,b){for(var c=[this.links,this.packages],e=0,f=c.length;e<f;e++)for(var g=c[e],h=0,i=g.length;h<i;h++){if(g.from===a)g.from=b;if(g.to===a)g.to=b}};
links.Network.prototype._findLink=function(a){for(var b=this.links,c=0,e=b.length;c<e;c++)if(b[c].id===a)return c};
links.Network.prototype.addPackages=function(a){if(a!=void 0){var b=this._getColumnNames(a);if(b.from===void 0)throw"Column 'from' missing in table with packages";if(b.to===void 0)throw"Column 'to' missing in table with packages";for(var c=a.getNumberOfRows(),e=0;e<c;e++){var f={},g;for(g in b)b.hasOwnProperty(g)&&(f[g]=a.getValue(e,b[g]));this._createPackage(f)}this._updateValueRange(this.packages);this.start()}};
links.Network.prototype.setPackages=function(a){this.packagesTable=a;this.packages=[];if(a!==void 0){var b=this._getColumnNames(a);if(b.from===void 0)throw"Column 'from' missing in table with packages";if(b.to===void 0)throw"Column 'to' missing in table with packages";for(var c=a.getNumberOfRows(),e=0;e<c;e++){var f={},g;for(g in b)b.hasOwnProperty(g)&&(f[g]=a.getValue(e,b[g]));this.hasTimestamps=this.hasTimestamps||f.timestamp!==void 0;this._createPackage(f)}this._updateValueRange(this.packages)}};
links.Network.prototype._filterPackages=function(a){if(this.packagesTable!=void 0){var b=this._getColumnNames(this.packagesTable);if(b.from==void 0)throw"Column 'from' missing in table with packages";if(b.to==void 0)throw"Column 'to' missing in table with packages";this.packages=[];for(var c=this.packagesTable.getNumberOfRows(),e=0;e<c;e++){var f={},g;for(g in b)b.hasOwnProperty(g)&&(f[g]=this.packagesTable.getValue(e,b[g]));var h=f.timestamp?f.timestamp:void 0,i=!0;h!==void 0&&a!==void 0&&h>a&&(i=
!1);if(i===!0&&f.progress==void 0){var j=f.duration||this.constants.packages.duration,h=(a.getTime()-h.getTime())/1E3;h<j?f.progress=h/j:i=!1}i===!0&&this._createPackage(f)}this.start()}};
links.Network.prototype._createPackage=function(a){var b=a.action?a.action:"create";if(b==="create"){var c=a.id,b=c!==void 0?this._findPackage(c):void 0,a=new links.Network.Package(a,this,this.images,this.constants);b!==void 0?this.packages[b]=a:this.packages.push(a);if(a.isMoving())this.hasMovingPackages=!0}else if(b==="update"){c=a.id;if(c===void 0)throw"Cannot update a link without id";b=this._findPackage(c);if(b!==void 0)this.packages[b].setProperties(a);else if(a=new links.Network.Package(a,
this,this.images,this.constants),this.packages.push(a),a.isMoving())this.hasMovingPackages=!0}else if(b==="delete"){c=a.id;if(c===void 0)throw"Cannot delete package without its id";b=this._findPackage(c);if(b!==void 0)this.packages.splice(b,1);else throw"Package with id "+c+" not found";}else throw"Unknown action "+b+". Choose 'create', 'update', or 'delete'.";};links.Network.prototype._findPackage=function(a){for(var b=this.packages,c=0,e=b.length;c<e;c++)if(b[c].id===a)return c};
links.Network.prototype._getColumnNames=function(a){for(var b=a.getNumberOfColumns(),c={},e=0;e<b;e++){var f=a.getColumnLabel(e);c[f]=e}return c};links.Network.prototype._updateValueRange=function(a){for(var b=a.length,c=void 0,e=void 0,f=0;f<b;f++){var g=a[f].getValue();g!==void 0&&(c=c===void 0?g:Math.min(g,c),e=e===void 0?g:Math.max(g,e))}if(c!==void 0&&e!==void 0)for(f=0;f<b;f++)a[f].setValueRange(c,e)};
links.Network.prototype.setTimestamp=function(a){this._filterNodes(a);this._filterLinks(a);this._filterPackages(a)};
links.Network.prototype._getRange=function(){for(var a=void 0,b=void 0,c=[this.nodesTable,this.linksTable],e=0,f=c.length;e<f;e++){var g=c[e];if(g!==void 0){var h=this._getColumnNames(g),i=h.timestamp,h=i&&g.getColumnType(i)==="datetime";if(i!=void 0)i=g.getColumnRange(i),i.min=i.min&&i.min instanceof Date?i.min.getTime():i.min,i.max=i.max&&i.max instanceof Date?i.max.getTime():i.max,i.min!=void 0&&(a=a?Math.min(i.min,a):i.min),i.max!=void 0&&(b=b?Math.max(i.max,b):i.max)}}if(this.packagesTable&&
(c=this.packagesTable,h=this._getColumnNames(c),i=h.timestamp,e=h.progress,f=h.duration,h=i&&c.getColumnType(i)==="datetime",i!==void 0))for(var g=0,j=c.getNumberOfRows();g<j;g++){var k=c.getValue(g,i),o=e?c.getValue(g,e):void 0,p=f?c.getValue(g,f):this.constants.packages.duration,k=h?k.getTime():k;if(k!=void 0)var n=k,k=o?k:k+p*1E3,a=a?Math.min(n,a):n,b=b?Math.max(k,b):k}return{start:h?new Date(a):a,end:h?new Date(b):b}};links.Network.prototype.animationStart=function(){this.slider&&this.slider.play()};
links.Network.prototype.animationStop=function(){this.slider&&this.slider.stop()};links.Network.prototype.setAnimationFramerate=function(a){this.slider&&this.slider.setFramerate(a)};links.Network.prototype.setAnimationDuration=function(a){this.slider&&this.slider.setDuration(a)};links.Network.prototype.setAnimationAcceleration=function(a){this.slider&&this.slider.setAcceleration(a)};links.Network.prototype.redraw=function(){this._setSize(this.width,this.height);this._redraw()};
links.Network.prototype._redraw=function(){var a=this.frame.canvas.getContext("2d");a.clearRect(0,0,this.frame.canvas.width,this.frame.canvas.height);a.save();a.translate(this.translation.x,this.translation.y);a.scale(this.scale,this.scale);this._drawLinks(a);this._drawNodes(a);this._drawPackages(a);this._drawSlider();a.restore()};
links.Network.prototype._setTranslation=function(a,b){if(this.translation===void 0)this.translation={x:0,y:0};if(a!==void 0)this.translation.x=a;if(b!==void 0)this.translation.y=b};links.Network.prototype._getTranslation=function(){return{x:this.translation.x,y:this.translation.y}};links.Network.prototype._setScale=function(a){this.scale=a};links.Network.prototype._getScale=function(){return this.scale};links.Network.prototype._xToCanvas=function(a){return(a-this.translation.x)/this.scale};
links.Network.prototype._canvasToX=function(a){return a*this.scale+this.translation.x};links.Network.prototype._yToCanvas=function(a){return(a-this.translation.y)/this.scale};links.Network.prototype._canvasToY=function(a){return a*this.scale+this.translation.y};links.Network.prototype._getNode=function(a){for(var b=0;b<this.nodes.length;b++)if(this.nodes[b].id==a)return this.nodes[b];return null};
links.Network.prototype._drawNodes=function(a){for(var b=this.nodes,c=[],e=0,f=b.length;e<f;e++)b[e].isSelected()?c.push(e):b[e].draw(a);e=0;for(f=c.length;e<f;e++)b[c[e]].draw(a)};links.Network.prototype._drawLinks=function(a){for(var b=this.links,c=0,e=b.length;c<e;c++)b[c].draw(a)};links.Network.prototype._drawPackages=function(a){for(var b=this.packages,c=0,e=b.length;c<e;c++)b[c].draw(a)};
links.Network.prototype._drawSlider=function(){if(this.hasTimestamps){var a=this.frame.slider;if(a===void 0){a=document.createElement("div");a.style.position="absolute";a.style.bottom="0px";a.style.left="0px";a.style.right="0px";a.style.backgroundColor="rgba(255, 255, 255, 0.7)";this.frame.slider=a;this.frame.slider.style.padding="10px";this.frame.appendChild(a);var b=this._getRange();this.slider=new links.Network.Slider(a);this.slider.setLoop(!1);this.slider.setRange(b.start,b.end);var c=this,a=
function(){var a=c.slider.getValue();c.setTimestamp(a);c.redraw()};this.slider.setOnChangeCallback(a);a()}}else if(a=this.frame.slider,a!==void 0)this.frame.removeChild(a),this.slider=this.frame.slider=void 0};
links.Network.prototype._reposition=function(){for(var a=this.constants.links.length*2,b=this.frame.canvas.clientWidth/2,c=this.frame.canvas.clientHeight/2,e=0;e<this.nodes.length;e++){var f=2*Math.PI*(e/this.nodes.length);if(!this.nodes[e].xFixed)this.nodes[e].x=b+a*Math.cos(f);if(!this.nodes[e].yFixed)this.nodes[e].y=c+a*Math.sin(f)}};
links.Network.prototype._doStabilize=function(){for(var a=new Date,b=0,c=this.constants.minVelocity,e=!1;!e&&b<this.constants.maxIterations;)this._calculateForces(),this._discreteStepNodes(),e=!this.isMoving(c),b++;console.log("Stabilized in "+(new Date-a)+" ms, "+b+" iterations")};
links.Network.prototype._calculateForces=function(){for(var a=this.nodes,b=this.links,c=this.frame.canvas.clientWidth/2,e=this.frame.canvas.clientHeight/2,f=0;f<a.length;f++){var g=c-a[f].x,h=e-a[f].y,g=Math.atan2(h,g),h=Math.cos(g)*0.01,g=Math.sin(g)*0.01;this.nodes[f]._setForce(h,g)}c=this.constants.nodes.distance;for(f=0;f<a.length;f++)for(e=f+1;e<this.nodes.length;e++){var g=a[e].x-a[f].x,h=a[e].y-a[f].y,i=Math.sqrt(g*g+h*h),g=Math.atan2(h,g),i=1/(1+Math.exp((i/c-1)*10)),h=Math.cos(g)*i,g=Math.sin(g)*
i;this.nodes[f]._addForce(-h,-g);this.nodes[e]._addForce(h,g)}a=0;for(f=b.length;a<f;a++)c=b[a],g=c.to.x-c.from.x,h=c.to.y-c.from.y,e=c.length,i=Math.sqrt(g*g+h*h),g=Math.atan2(h,g),e=c.stiffness*(e-i),h=Math.cos(g)*e,g=Math.sin(g)*e,c.from._addForce(-h,-g),c.to._addForce(h,g)};links.Network.prototype.isMoving=function(a){for(var b=this.nodes,c=0,e=b.length;c<e;c++)if(b[c].isMoving(a))return!0;return!1};
links.Network.prototype._discreteStepNodes=function(){for(var a=this.refreshRate/1E3,b=this.nodes,c=0,e=b.length;c<e;c++)b[c].discreteStep(a)};links.Network.prototype._discreteStepPackages=function(){for(var a=this.refreshRate/1E3,b=this.packages,c=0,e=b.length;c<e;c++)b[c].discreteStep(a)};
links.Network.prototype._deleteFinishedPackages=function(){for(var a=0,b=!1;a<this.packages.length;)this.packages[a].isFinished()?(this.packages.splice(a,1),a--):this.packages[a].isMoving()&&(b=!0),a++;this.hasMovingPackages=b};
links.Network.prototype.start=function(){if(this.hasMovingNodes)this._calculateForces(),this._discreteStepNodes(),this.hasMovingNodes=this.isMoving(this.constants.minVelocity);this.hasMovingPackages&&(this._discreteStepPackages(),this._deleteFinishedPackages());if(this.hasMovingNodes||this.hasMovingLinks||this.hasMovingPackages){if(!this.timer){var a=this;this.timer=window.setTimeout(function(){a.timer=void 0;a.start();a._redraw()},this.refreshRate)}}else this._redraw()};
links.Network.prototype.stop=function(){if(this.timer)window.clearInterval(this.timer),this.timer=void 0};links.Network.addEventListener=function(a,b,c,e){a.addEventListener?(e===void 0&&(e=!1),b==="mousewheel"&&navigator.userAgent.indexOf("Firefox")>=0&&(b="DOMMouseScroll"),a.addEventListener(b,c,e)):a.attachEvent("on"+b,c)};
links.Network.removeEventListener=function(a,b,c,e){a.removeEventListener?(e===void 0&&(e=!1),b==="mousewheel"&&navigator.userAgent.indexOf("Firefox")>=0&&(b="DOMMouseScroll"),a.removeEventListener(b,c,e)):a.detachEvent("on"+b,c)};links.Network.stopPropagation=function(a){if(!a)a=window.event;a.stopPropagation?a.stopPropagation():a.cancelBubble=!0};links.Network.preventDefault=function(a){if(!a)a=window.event;a.preventDefault?a.preventDefault():a.returnValue=!1};
links.Network._getAbsoluteLeft=function(a){for(var b=0;a!=null;)b+=a.offsetLeft,b-=a.scrollLeft,a=a.offsetParent;!document.body.scrollLeft&&window.pageXOffset&&(b-=window.pageXOffset);return b};links.Network._getAbsoluteTop=function(a){for(var b=0;a!=null;)b+=a.offsetTop,b-=a.scrollTop,a=a.offsetParent;!document.body.scrollTop&&window.pageYOffset&&(b-=window.pageYOffset);return b};
links.Network.Node=function(a,b,c,e){this.selected=!1;this.group=e.nodes.group;this.fontSize=e.nodes.fontSize;this.fontFace=e.nodes.fontFace;this.fontColor=e.nodes.fontColor;this.borderColor=e.nodes.borderColor;this.backgroundColor=e.nodes.backgroundColor;this.highlightColor=e.nodes.highlightColor;this.radiusMin=e.nodes.radiusMin;this.radiusMax=e.nodes.radiusMax;this.id=void 0;this.style=e.nodes.style;this.image=e.nodes.image;this.y=this.x=0;this.yFixed=this.xFixed=!1;this.radius=e.nodes.radius;this.radiusFixed=
!1;this.imagelist=b;this.grouplist=c;this.setProperties(a);this.mass=50;this.vy=this.vx=this.fy=this.fx=0;this.damping=0.5};
links.Network.Node.prototype.setProperties=function(a){if(a){if(a.id!=void 0)this.id=a.id;if(a.style!=void 0)this.style=a.style;if(a.text!=void 0)this.text=a.text;if(a.title!=void 0)this.title=a.title;if(a.image!=void 0)this.image=a.image;if(a.group!=void 0)this.group=a.group;if(a.x!=void 0)this.x=a.x;if(a.y!=void 0)this.y=a.y;if(a.radius!=void 0)this.radius=a.radius;if(a.value!=void 0)this.value=a.value;if(a.timestamp!=void 0)this.timestamp=a.timestamp;if(this.id===void 0)throw"Node must have an id";
if(this.group){var b=this.grouplist.get(this.group),c;for(c in b)b.hasOwnProperty(c)&&(this[c]=b[c])}if(this.image!=void 0)if(this.imagelist)this.imageObj=this.imagelist.load(this.image);else throw"No imagelist provided";this.xFixed=this.xFixed||a.x!=void 0;this.yFixed=this.yFixed||a.y!=void 0;this.radiusFixed=this.radiusFixed||a.radius!=void 0;switch(this.style){case "database":this.draw=this._drawDatabase;break;case "rect":this.draw=this._drawRect;break;case "circle":this.draw=this._drawCircle;
break;case "image":this.draw=this._drawImage;break;case "text":this.draw=this._drawText;break;case "dot":this.draw=this._drawDot;break;default:this.draw=this._drawText}this.height=this.width=void 0}};links.Network.Node.prototype.select=function(){this.selected=!0;this._reset()};links.Network.Node.prototype.unselect=function(){this.selected=!1;this._reset()};links.Network.Node.prototype._reset=function(){this.height=this.width=void 0};links.Network.Node.prototype.getTitle=function(){return this.title};
links.Network.Node.prototype._setForce=function(a,b){this.fx=a;this.fy=b};links.Network.Node.prototype._addForce=function(a,b){this.fx+=a;this.fy+=b};links.Network.Node.prototype.discreteStep=function(a){this.xFixed||(this.vx+=(this.fx+-this.damping*this.vx)/this.mass/a,this.x+=this.vx/a);this.yFixed||(this.vy+=(this.fy+-this.damping*this.vy)/this.mass/a,this.y+=this.vy/a)};links.Network.Node.prototype.isFixed=function(){return this.xFixed&&this.yFixed};
links.Network.Node.prototype.isMoving=function(a){return this.vx>a||this.vx<-a||this.vy>a||this.vy<-a||!this.xFixed&&Math.abs(this.fx)>0.005||!this.yFixed&&Math.abs(this.fy)>0.005};links.Network.Node.prototype.isSelected=function(){return this.selected};links.Network.Node.prototype.getValue=function(){return this.value};links.Network.Node.prototype.getDistance=function(a,b){var c=this.x-a,e=this.y-b;return Math.sqrt(c*c+e*e)};
links.Network.Node.prototype.setValueRange=function(a,b){if(!this.radiusFixed&&this.value!==void 0)this.radius=(this.value-a)*((this.radiusMax-this.radiusMin)/(b-a))+this.radiusMin};links.Network.Node.prototype.draw=function(){throw"Draw method not initialized for node";};links.Network.Node.prototype.isOverlappingWith=function(a){return this.left<a.right&&this.left+this.width>a.left&&this.top<a.bottom&&this.top+this.height>a.top};
links.Network.Node.prototype._drawImage=function(a){this.left=this.x-this.imageObj.width/2;this.top=this.y-this.imageObj.height/2;this.width=this.imageObj.width;this.height=this.imageObj.height+this.fontSize;if(this.imageObj){a.drawImage(this.imageObj,this.left,this.top);var b=this.y+this.imageObj.height/2}else b=this.y;this._text(a,this.text,this.x,b,void 0,"top")};
links.Network.Node.prototype._drawRect=function(a){if(!this.width){var b=this.getTextSize(a);this.width=b.width+10;this.height=b.height+10}this.left=this.x-this.width/2;this.top=this.y-this.height/2;a.strokeStyle=this.borderColor;a.fillStyle=this.selected?this.highlightColor:this.backgroundColor;a.lineWidth=this.selected?2:1;a.roundRect(this.left,this.top,this.width,this.height,this.radius);a.fill();a.stroke();this._text(a,this.text,this.x,this.y)};
links.Network.Node.prototype._drawDatabase=function(a){if(!this.width)this.height=this.width=this.getTextSize(a).width+10;this.left=this.x-this.width/2;this.top=this.y-this.height/2;a.strokeStyle=this.borderColor;a.fillStyle=this.selected?this.highlightColor:this.backgroundColor;a.lineWidth=this.selected?2:1;a.database(this.x-this.width/2,this.y-this.height*0.5,this.width,this.height);a.fill();a.stroke();this._text(a,this.text,this.x,this.y)};
links.Network.Node.prototype._drawCircle=function(a){if(!this.width){var b=this.getTextSize(a),b=Math.max(b.width,b.height)+10;this.radius=b/2;this.height=this.width=b}this.left=this.x-this.width/2;this.top=this.y-this.height/2;a.strokeStyle=this.borderColor;a.fillStyle=this.selected?this.highlightColor:this.backgroundColor;a.lineWidth=this.selected?2:1;a.circle(this.x,this.y,this.radius);a.fill();a.stroke();this._text(a,this.text,this.x,this.y)};
links.Network.Node.prototype._drawDot=function(a){if(!this.width)this.height=this.width=2*this.radius;this.left=this.x-this.width/2;this.top=this.y-this.height/2;a.strokeStyle=this.borderColor;a.fillStyle=this.selected?this.highlightColor:this.backgroundColor;a.lineWidth=this.selected?2:1;a.circle(this.x,this.y,this.radius);a.fill();a.stroke()};
links.Network.Node.prototype._drawText=function(a){if(!this.width){var b=this.getTextSize(a);this.width=b.width+10;this.height=b.height+10}this.left=this.x-this.width/2;this.top=this.y-this.height/2;this._text(a,this.text,this.x,this.y)};
links.Network.Node.prototype._text=function(a,b,c,e,f,g){if(b){a.font=(this.selected?"bold ":"")+this.fontSize+"px "+this.fontFace;a.fillStyle=this.fontColor||"black";a.textAlign=f||"center";a.textBaseline=g||"middle";b=b.split("\n");f=b.length;g=this.fontSize+4;e+=(1-f)/2*g;for(var h=0;h<f;h++)a.fillText(b[h],c,e),e+=g}};
links.Network.Node.prototype.getTextSize=function(a){if(this.text!=void 0){a.font=(this.selected?"bold ":"")+this.fontSize+"px "+this.fontFace;for(var b=this.text.split("\n"),c=(this.fontSize+4)*b.length,e=0,f=0,g=b.length;f<g;f++)e=Math.max(e,a.measureText(b[f]).width);return{width:e,height:c}}else return{width:0,height:0}};
links.Network.Link=function(a,b,c){if(!b)throw"No network provided";this.network=b;this.widthMin=c.links.widthMin;this.widthMax=c.links.widthMax;this.id=void 0;this.style=c.links.style;this.title=void 0;this.width=c.links.width;this.value=void 0;this.length=c.links.length;this.stiffness=void 0;this.color=c.links.color;this.timestamp=void 0;this.lengthFixed=this.widthFixed=!1;this.setProperties(a)};
links.Network.Link.prototype.setProperties=function(a){if(a){if(a.from!=void 0)this.from=this.network._getNode(a.from);if(a.to!=void 0)this.to=this.network._getNode(a.to);if(a.id!=void 0)this.id=a.id;if(a.style!=void 0)this.style=a.style;if(a.title!=void 0)this.title=a.title;if(a.width!=void 0)this.width=a.width;if(a.value!=void 0)this.value=a.value;if(a.length!=void 0)this.length=a.length;if(a.color!=void 0)this.color=a.color;if(a.timestamp!=void 0)this.timestamp=a.timestamp;if(!this.from)throw"Node with id "+
a.from+" not found";if(!this.to)throw"Node with id "+a.to+" not found";this.widthFixed=this.widthFixed||a.width!=void 0;this.lengthFixed=this.lengthFixed||a.length!=void 0;this.stiffness=1/this.length;if(this.style==="arrow")this.arrows=[0.5],this.animation=!1;else if(this.style==="moving-arrows"){this.arrows=[];for(a=0;a<3;a++)this.arrows.push(a/3);this.animation=!0}else this.style==="moving-dot"?(this.dot=0,this.animation=!0):this.animation=!1;switch(this.style){case "line":this.draw=this._drawLine;
break;case "arrow":this.draw=this._drawArrow;break;case "moving-arrows":this.draw=this._drawMovingArrows;break;case "moving-dot":this.draw=this._drawMovingDot;break;default:this.draw=this._drawLine}}};links.Network.Link.prototype.isMoving=function(){return this.animation};links.Network.Link.prototype.getTitle=function(){return this.title};links.Network.Link.prototype.getValue=function(){return this.value};
links.Network.Link.prototype.setValueRange=function(a,b){if(!this.widthFixed&&this.value!==void 0)this.width=(this.value-a)*((this.widthMax-this.widthMin)/(b-a))+this.widthMin};links.Network.Link.prototype.isLengthFixed=function(){return this.lengthFixed};links.Network.Link.prototype.getLength=function(){return this.length};links.Network.Link.prototype.setLength=function(a){if(!this.lengthFixed)this.length=a};
links.Network.Link.prototype.draw=function(){throw"Method draw not initialized in link";};links.Network.Link.prototype.isOverlappingWith=function(a){return links.Network._dist(this.from.x,this.from.y,this.to.x,this.to.y,a.left,a.top)<10};links.Network._dist=function(a,b,c,e,f,g){c-=a;e-=b;var h=((f-a)*c+(g-b)*e)/(c*c+e*e);h>1?h=1:h<0&&(h=0);a=a+h*c-f;b=b+h*e-g;return d=Math.sqrt(a*a+b*b)};
links.Network.Link.prototype._drawLine=function(a){a.strokeStyle=this.color;a.lineWidth=this.width;a.beginPath();a.moveTo(this.from.x,this.from.y);a.lineTo(this.to.x,this.to.y);a.stroke()};links.Network.Link.prototype._drawMovingArrows=function(a){this._drawArrow(a);for(var b in this.arrows)this.arrows.hasOwnProperty(b)&&(this.arrows[b]+=0.02,this.arrows[b]>1&&(this.arrows[b]=0))};
links.Network.Link.prototype._drawMovingDot=function(a){a.strokeStyle=this.color;a.fillStyle=this.color;a.lineWidth=this.width;a.beginPath();a.moveTo(this.from.x,this.from.y);a.lineTo(this.to.x,this.to.y);a.stroke();a.circle((1-this.dot)*this.from.x+this.dot*this.to.x,(1-this.dot)*this.from.y+this.dot*this.to.y,4+this.width*2);a.fill();this.dot+=0.05;if(this.dot>1)this.dot=0};
links.Network.Link.prototype._drawArrow=function(a){a.strokeStyle=this.color;a.fillStyle=this.color;a.lineWidth=this.width;a.beginPath();a.moveTo(this.from.x,this.from.y);a.lineTo(this.to.x,this.to.y);a.stroke();var b=Math.atan2(this.to.y-this.from.y,this.to.x-this.from.x),c=10+5*this.width,e;for(e in this.arrows)if(this.arrows.hasOwnProperty(e)){var f=this.arrows[e];a.arrow((1-f)*this.from.x+f*this.to.x,(1-f)*this.from.y+f*this.to.y,b,c);a.fill();a.stroke()}};
links.Network.Images=function(){this.images={};this.callback=void 0};links.Network.Images.prototype.setOnloadCallback=function(a){this.callback=a};links.Network.Images.prototype.load=function(a){var b=this.images[a];if(b==void 0){var c=this,b=new Image;this.images[a]=b;b.onload=function(){c.callback&&c.callback(this)};b.src=a}return b};
links.Network.Package=function(a,b,c,e){if(b==void 0)throw"No network provided";this.radiusMin=e.packages.radiusMin;this.radiusMax=e.packages.radiusMax;this.imagelist=c;this.network=b;this.title=this.to=this.from=this.id=void 0;this.style=e.packages.style;this.radius=e.packages.radius;this.color=e.packages.color;this.image=e.packages.image;this.value=void 0;this.progress=0;this.timestamp=void 0;this.duration=e.packages.duration;this.autoProgress=!0;this.radiusFixed=!1;this.setProperties(a,b)};
links.Network.Package.DEFAULT_DURATION=1;
links.Network.Package.prototype.setProperties=function(a){if(a){if(a.from!=void 0)this.from=this.network._getNode(a.from);if(a.to!=void 0)this.to=this.network._getNode(a.to);if(!this.from)throw"Node with id "+a.from+" not found";if(!this.to)throw"Node with id "+a.to+" not found";if(a.id!=void 0)this.id=a.id;if(a.title!=void 0)this.title=a.title;if(a.style!=void 0)this.style=a.style;if(a.radius!=void 0)this.radius=a.radius;if(a.value!=void 0)this.value=a.value;if(a.image!=void 0)this.image=a.image;
if(a.color!=void 0)this.color=a.color;if(a.progress!=void 0)this.progress=a.progress;if(a.timestamp!=void 0)this.timestamp=a.timestamp;if(a.duration!=void 0)this.duration=a.duration;this.radiusFixed=this.radiusFixed||a.radius!=void 0;this.autoProgress=this.autoProgress==!0?a.progress==void 0:!1;if(this.progress<0)this.progress=0;if(this.progress>1)this.progress=1;if(this.image!=void 0)if(this.imagelist)this.imageObj=this.imagelist.load(this.image);else throw"No imagelist provided";switch(this.style){case "dot":this.draw=
this._drawDot;break;case "image":this.draw=this._drawImage;break;default:this.draw=this._drawDot}}};links.Network.Package.prototype.setProgress=function(a){this.progress=a;this.autoProgress=!1};links.Network.Package.prototype.isFinished=function(){return this.autoProgress==!0&&this.progress>=1};links.Network.Package.prototype.isMoving=function(){return this.autoProgress||this.isFinished()};
links.Network.Package.prototype.discreteStep=function(a){if(this.autoProgress==!0&&(this.progress+=parseFloat(a)/this.duration,this.progress>1))this.progress=1};links.Network.Package.prototype.draw=function(){throw"Draw method not initialized for package";};links.Network.Package.prototype.isOverlappingWith=function(a){var b=Math.max(this.radius,10),c=this._getPosition();return c.x-b<a.right&&c.x+b>a.left&&c.y-b<a.bottom&&c.y+b>a.top};
links.Network.Package.prototype._getPosition=function(){return{x:(1-this.progress)*this.from.x+this.progress*this.to.x,y:(1-this.progress)*this.from.y+this.progress*this.to.y}};links.Network.Package.prototype.getTitle=function(){return this.title};links.Network.Package.prototype.getValue=function(){return this.value};links.Network.Package.prototype.getDistance=function(a,b){var c=this._getPosition(),e=c.x-a,c=c.y-b;return Math.sqrt(e*e+c*c)};
links.Network.Package.prototype.setValueRange=function(a,b){if(!this.radiusFixed&&this.value!==void 0)this.radius=(this.value-a)*((this.radiusMax-this.radiusMin)/(b-a))+this.radiusMin};links.Network.Package.prototype._drawDot=function(a){a.fillStyle=this.color;var b=this._getPosition();a.circle(b.x,b.y,this.radius);a.fill()};
links.Network.Package.prototype._drawImage=function(a){if(this.imageObj){var b=this._getPosition();a.drawImage(this.imageObj,b.x-this.imageObj.width/2,b.y-this.imageObj.height/2)}else console.log("image still loading...")};links.Network.Groups=function(){this.clear();this.defaultIndex=0};
links.Network.Groups.DEFAULT=[{borderColor:"#2B7CE9",backgroundColor:"#97C2FC",highlightColor:"#D2E5FF"},{borderColor:"#FFA500",backgroundColor:"#FFFF00",highlightColor:"#FFFFA3"},{borderColor:"#FA0A10",backgroundColor:"#FB7E81",highlightColor:"#FFAFB1"},{borderColor:"#41A906",backgroundColor:"#7BE141",highlightColor:"#A1EC76"},{borderColor:"#E129F0",backgroundColor:"#EB7DF4",highlightColor:"#F0B3F5"},{borderColor:"#7C29F0",backgroundColor:"#AD85E4",highlightColor:"#D3BDF0"},{borderColor:"#C37F00",
backgroundColor:"#FFA807",highlightColor:"#FFCA66"},{borderColor:"#4220FB",backgroundColor:"#6E6EFD",highlightColor:"#9B9BFD"},{borderColor:"#FD5A77",backgroundColor:"#FFC0CB",highlightColor:"#FFD1D9"},{borderColor:"#4AD63A",backgroundColor:"#C2FABC",highlightColor:"#E6FFE3"}];links.Network.Groups.prototype.clear=function(){this.groups={};this.groups.length=function(){var a=0,b;for(b in this)this.hasOwnProperty(b)&&a++;return a}};
links.Network.Groups.prototype.get=function(a){var b=this.groups[a];if(b==void 0){var c=this.defaultIndex%links.Network.Groups.DEFAULT.length;this.defaultIndex++;b={};b.borderColor=links.Network.Groups.DEFAULT[c].borderColor;b.backgroundColor=links.Network.Groups.DEFAULT[c].backgroundColor;b.highlightColor=links.Network.Groups.DEFAULT[c].highlightColor;this.groups[a]=b}return b};links.Network.Groups.prototype.add=function(a,b){return this.groups[a]=b};
links.Network.Slider=function(a){if(a===void 0)throw"Error: No container element defined";this.container=a;this.frame=document.createElement("DIV");this.frame.style.width="100%";this.frame.style.position="relative";this.title=document.createElement("DIV");this.title.style.margin="2px";this.title.style.marginBottom="5px";this.title.innerHTML="";this.container.appendChild(this.title);this.frame.prev=document.createElement("INPUT");this.frame.prev.type="BUTTON";this.frame.prev.value="Prev";this.frame.appendChild(this.frame.prev);
this.frame.play=document.createElement("INPUT");this.frame.play.type="BUTTON";this.frame.play.value="Play";this.frame.appendChild(this.frame.play);this.frame.next=document.createElement("INPUT");this.frame.next.type="BUTTON";this.frame.next.value="Next";this.frame.appendChild(this.frame.next);this.frame.bar=document.createElement("INPUT");this.frame.bar.type="BUTTON";this.frame.bar.style.position="absolute";this.frame.bar.style.border="1px solid red";this.frame.bar.style.width="100px";this.frame.bar.style.height=
"6px";this.frame.bar.style.borderRadius="2px";this.frame.bar.style.MozBorderRadius="2px";this.frame.bar.style.border="1px solid #7F7F7F";this.frame.bar.style.backgroundColor="#E5E5E5";this.frame.appendChild(this.frame.bar);this.frame.slide=document.createElement("INPUT");this.frame.slide.type="BUTTON";this.frame.slide.style.margin="0px";this.frame.slide.value=" ";this.frame.slide.style.position="relative";this.frame.slide.style.left="-100px";this.frame.appendChild(this.frame.slide);var b=this;this.frame.slide.onmousedown=
function(a){b._onMouseDown(a)};this.frame.prev.onclick=function(a){b.prev(a)};this.frame.play.onclick=function(a){b.togglePlay(a)};this.frame.next.onclick=function(a){b.next(a)};this.container.appendChild(this.frame);this.playTimeout=this.onChangeCallback=void 0;this.framerate=20;this.duration=10;this.doLoop=!0;this.step=this.value=this.end=this.start=0;this.rangeIsDate=!1;this.redraw()};links.Network.Slider.prototype._updateStep=function(){this.step=(this.end-this.start)/(this.duration*this.framerate)};
links.Network.Slider.prototype.prev=function(){this._setValue(this.value-this.step)};links.Network.Slider.prototype.next=function(){this._setValue(this.value+this.step)};
links.Network.Slider.prototype.playNext=function(){var a=new Date;if(!this.leftButtonDown)if(this.value+this.step<this.end)this._setValue(this.value+this.step);else if(this.doLoop)this._setValue(this.start);else{this._setValue(this.end);this.stop();return}var a=Math.max(1E3/this.framerate-(new Date-a),0),b=this;this.playTimeout=setTimeout(function(){b.playNext()},a)};links.Network.Slider.prototype.togglePlay=function(){this.playTimeout===void 0?this.play():this.stop()};
links.Network.Slider.prototype.play=function(){this.frame.play.value="Stop";this.playNext()};links.Network.Slider.prototype.stop=function(){this.frame.play.value="Play";clearInterval(this.playTimeout);this.playTimeout=void 0};links.Network.Slider.prototype.setOnChangeCallback=function(a){this.onChangeCallback=a};links.Network.Slider.prototype.setFramerate=function(a){this.framerate=a;this._updateStep()};links.Network.Slider.prototype.getFramerate=function(){return this.framerate};
links.Network.Slider.prototype.setDuration=function(a){this.duration=a;this._updateStep()};links.Network.Slider.prototype.setAcceleration=function(a){this.duration=(this.end-this.start)/1E3/a;this._updateStep()};links.Network.Slider.prototype.setLoop=function(a){this.doLoop=a};links.Network.Slider.prototype.getLoop=function(){return this.doLoop};links.Network.Slider.prototype.onChange=function(){if(this.onChangeCallback!==void 0)this.onChangeCallback()};
links.Network.Slider.prototype.redraw=function(){var a=this.frame.clientWidth-this.frame.prev.clientWidth-this.frame.play.clientWidth-this.frame.next.clientWidth-30;this.frame.bar.style.top=this.frame.clientHeight/2-this.frame.bar.offsetHeight/2+"px";this.frame.bar.style.width=a+"px";this.frame.slide.title=this.getValue();this.frame.slide.style.left=this._valueToLeft(this.value)+"px";this.title.innerHTML=this.getValue()};
links.Network.Slider.prototype.setRange=function(a,b){a===void 0||a===null||a===NaN?(this.start=0,this.rangeIsDate=!1):a instanceof Date?(this.start=a.getTime(),this.rangeIsDate=!0):(this.start=a,this.rangeIsDate=!1);this.end=b===void 0||b===null||b===NaN?this.start instanceof Date?new Date(this.start):this.start:b instanceof Date?b.getTime():b;this.value=this.start;this._updateStep();this.redraw()};
links.Network.Slider.prototype._setValue=function(a){this.value=this._limitValue(a);this.redraw();this.onChange()};links.Network.Slider.prototype.getValue=function(){return this.rangeIsDate?new Date(this.value):this.value};links.Network.Slider.prototype.offset=3;links.Network.Slider.prototype._leftToValue=function(a){var b=parseFloat(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return this._limitValue((a-this.offset)/b*(this.end-this.start)+this.start)};
links.Network.Slider.prototype._valueToLeft=function(a){var b=parseFloat(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return(this.end>this.start?(a-this.start)/(this.end-this.start)*b:0)+this.offset};links.Network.Slider.prototype._limitValue=function(a){if(a<this.start)a=this.start;if(a>this.end)a=this.end;return a};
links.Network.Slider.prototype._onMouseDown=function(a){if(this.leftButtonDown=a.which?a.which===1:a.button===1){this.startClientX=a.clientX;this.startSlideX=parseFloat(this.frame.slide.style.left);this.frame.style.cursor="move";var b=this;this.onmousemove=function(a){b._onMouseMove(a)};this.onmouseup=function(a){b._onMouseUp(a)};links.Network.addEventListener(document,"mousemove",this.onmousemove);links.Network.addEventListener(document,"mouseup",this.onmouseup);links.Network.preventDefault(a)}};
links.Network.Slider.prototype._onMouseMove=function(a){this._setValue(this._leftToValue(this.startSlideX+(a.clientX-this.startClientX)));links.Network.preventDefault(a)};links.Network.Slider.prototype._onMouseUp=function(a){this.frame.style.cursor="auto";this.leftButtonDown=!1;links.Network.removeEventListener(document,"mousemove",this.onmousemove);links.Network.removeEventListener(document,"mouseup",this.onmouseup);links.Network.preventDefault(a)};
links.Network.Popup=function(a,b,c,e){this.container=a?a:document.body;this.y=this.x=0;this.padding=5;b!==void 0&&c!==void 0&&this.setPosition(b,c);e!==void 0&&this.setText(e);this.frame=document.createElement("div");a=this.frame.style;a.position="absolute";a.visibility="hidden";a.border="1px solid #666";a.color="black";a.padding=this.padding+"px";a.backgroundColor="#FFFFC6";a.borderRadius="3px";a.MozBorderRadius="3px";a.WebkitBorderRadius="3px";a.boxShadow="3px 3px 4px #BFBFBF";a.whiteSpace="nowrap";
this.container.appendChild(this.frame)};links.Network.Popup.prototype.setPosition=function(a,b){this.x=parseInt(a);this.y=parseInt(b)};links.Network.Popup.prototype.setText=function(a){this.frame.innerHTML=a};
links.Network.Popup.prototype.show=function(a){a===void 0&&(a=!0);if(a){var b=this.frame.clientHeight,a=this.frame.clientWidth,c=this.frame.parentNode.clientHeight,e=this.frame.parentNode.clientWidth,f=this.y-b;f+b+this.padding>c&&(f=c-b-this.padding);if(f<this.padding)f=this.padding;b=this.x;b+a+this.padding>e&&(b=e-a-this.padding);if(b<this.padding)b=this.padding;this.frame.style.left=b+"px";this.frame.style.top=f+"px";this.frame.style.visibility="visible"}else this.hide()};
links.Network.Popup.prototype.hide=function(){this.frame.style.visibility="hidden"};CanvasRenderingContext2D.prototype.roundRect=function(a,b,c,e,f){var g=Math.PI/180;c-2*f<0&&(f=c/2);e-2*f<0&&(f=e/2);this.beginPath();this.moveTo(a+f,b);this.lineTo(a+c-f,b);this.arc(a+c-f,b+f,f,g*270,g*360,!1);this.lineTo(a+c,b+e-f);this.arc(a+c-f,b+e-f,f,g*0,g*90,!1);this.lineTo(a+f,b+e);this.arc(a+f,b+e-f,f,g*90,g*180,!1);this.lineTo(a,b+f);this.arc(a+f,b+f,f,g*180,g*270,!1)};
CanvasRenderingContext2D.prototype.circle=function(a,b,c){this.beginPath();this.arc(a,b,c,0,2*Math.PI,!1)};CanvasRenderingContext2D.prototype.ellipse=function(a,b,c,e){var f=c/2*0.5522848,g=e/2*0.5522848,h=a+c,i=b+e,c=a+c/2,e=b+e/2;this.beginPath();this.moveTo(a,e);this.bezierCurveTo(a,e-g,c-f,b,c,b);this.bezierCurveTo(c+f,b,h,e-g,h,e);this.bezierCurveTo(h,e+g,c+f,i,c,i);this.bezierCurveTo(c-f,i,a,e+g,a,e)};
CanvasRenderingContext2D.prototype.database=function(a,b,c,e){var f=e*(1/3),g=c/2*0.5522848,h=f/2*0.5522848,i=a+c,j=b+f,c=a+c/2,k=b+f/2,f=b+(e-f/2),e=b+e;this.beginPath();this.moveTo(i,k);this.bezierCurveTo(i,k+h,c+g,j,c,j);this.bezierCurveTo(c-g,j,a,k+h,a,k);this.bezierCurveTo(a,k-h,c-g,b,c,b);this.bezierCurveTo(c+g,b,i,k-h,i,k);this.lineTo(i,f);this.bezierCurveTo(i,f+h,c+g,e,c,e);this.bezierCurveTo(c-g,e,a,f+h,a,f);this.lineTo(a,k)};
CanvasRenderingContext2D.prototype.arrow=function(a,b,c,e){var f=a+e*0.5*Math.cos(c),g=b+e*0.5*Math.sin(c),h=a-e*0.5*Math.cos(c),i=b-e*0.5*Math.sin(c);a-=e*0.4*Math.cos(c);b-=e*0.4*Math.sin(c);var j=h+e/3*Math.cos(c+0.5*Math.PI),k=i+e/3*Math.sin(c+0.5*Math.PI);h+=e/3*Math.cos(c-0.5*Math.PI);c=i+e/3*Math.sin(c-0.5*Math.PI);this.beginPath();this.moveTo(f,g);this.lineTo(j,k);this.lineTo(a,b);this.lineTo(h,c);this.closePath()};
